Index: lib/libcapsicum/libcapsicum_host.c
===================================================================
--- lib/libcapsicum/libcapsicum_host.c	(.../stable/8)	(revision 0)
+++ lib/libcapsicum/libcapsicum_host.c	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,394 @@
+/*-
+ * Copyright (c) 2009-2010 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * WARNING: THIS IS EXPERIMENTAL SECURITY SOFTWARE THAT MUST NOT BE RELIED
+ * ON IN PRODUCTION SYSTEMS.  IT WILL BREAK YOUR SOFTWARE IN NEW AND
+ * UNEXPECTED WAYS.
+ *
+ * This software was developed at the University of Cambridge Computer
+ * Laboratory with support from a grant from Google, Inc.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $P4: //depot/projects/trustedbsd/capabilities/src/lib/libcapsicum/libcapsicum_host.c#16 $
+ */
+
+#include <sys/param.h>
+#include <sys/capability.h>
+#include <sys/mman.h>
+#include <sys/procdesc.h>
+#include <sys/sbuf.h>
+#include <sys/socket.h>
+#include <sys/uio.h>
+
+#include <err.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <libgen.h>
+#include <paths.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+
+#include "libcapsicum.h"
+#include "libcapsicum_internal.h"
+#include "libcapsicum_sandbox_api.h"
+
+#define	LIBCAPSICUM_CAPMASK_SOCK	(CAP_EVENT | CAP_READ | CAP_WRITE)
+#define	LIBCAPSICUM_CAPMASK_BIN	(CAP_READ | CAP_EVENT | CAP_FSTAT | \
+					    CAP_FSTATFS | \
+					    CAP_FEXECVE | CAP_MMAP | \
+					    CAP_MAPEXEC)
+#define	LIBCAPSICUM_CAPMASK_SANDBOX	LIBCAPSICUM_CAPMASK_BIN
+#define	LIBCAPSICUM_CAPMASK_LDSO	LIBCAPSICUM_CAPMASK_BIN
+#define LIBCAPSICUM_CAPMASK_LIBDIR	LIBCAPSICUM_CAPMASK_BIN \
+					 | CAP_LOOKUP | CAP_ATBASE
+#define LIBCAPSICUM_CAPMASK_FDLIST	CAP_READ | CAP_WRITE | CAP_FTRUNCATE \
+					 | CAP_FSTAT | CAP_MMAP
+
+extern char **environ;
+
+#define LD_ELF_CAP_SO		"ld-elf-cap.so.1"
+#define	PATH_LD_ELF_CAP_SO	"/libexec"
+
+int
+lch_autosandbox_isenabled(__unused const char *servicename)
+{
+
+	if (getenv("LIBCAPSICUM_NOAUTOSANDBOX") != NULL)
+		return (0);
+	return (1);
+}
+
+/*
+ * Once in the child process, create the new sandbox.
+ *
+ * XXX: A number of things happen here that are not safe after fork(),
+ * especially calls to err().
+ */
+static void
+lch_sandbox(int fd_sock, int fd_binary, int fd_rtld, u_int flags,
+    const char *binname, char *const argv[], struct lc_fdlist *userfds)
+{
+	struct sbuf *sbufp;
+	int shmfd = -1;
+	size_t fdlistsize;
+	struct lc_fdlist *fds;
+	void *shm;
+
+	/*
+	 * Inform the run-time linked of the binary's name.
+	 */
+	if (setenv("LD_BINNAME", binname, 1) == -1)
+		err(-1, "Error in setenv(LD_BINNAME)");
+
+	/*
+	 * Create an anonymous shared memory segment for the FD list.
+	 */
+	shmfd = shm_open(SHM_ANON, O_RDWR | O_CREAT | O_TRUNC, 0600);
+	if (shmfd < 0)
+		err(-1, "Error creating shared memory segment");
+
+	/*
+	 * Create and fill up the FD list.
+	 */
+	fds = lc_fdlist_new();
+	if (fds == NULL)
+		err(-1, "Error in lc_fdlist_new()");
+
+	if (lc_fdlist_addcap(fds, LIBCAPSICUM_FQNAME, "stdin", "",
+		STDIN_FILENO, 0) < 0)
+		err(-1, "Error in lc_fdlist_addcap(stdin)");
+
+	if (lc_fdlist_addcap(fds, LIBCAPSICUM_FQNAME, "stdout", "",
+		STDOUT_FILENO,
+		(flags & LCH_PERMIT_STDOUT) ? CAP_WRITE | CAP_SEEK : 0) < 0)
+		err(-1, "Error in lc_fdlist_addcap(stdout)");
+
+	if (lc_fdlist_addcap(fds, LIBCAPSICUM_FQNAME, "stderr", "",
+		STDERR_FILENO,
+		(flags & LCH_PERMIT_STDERR) ? CAP_WRITE | CAP_SEEK : 0) < 0)
+		err(-1, "Error in lc_fdlist_addcap(stderr)");
+
+	if (lc_fdlist_addcap(fds, LIBCAPSICUM_FQNAME, "socket", "",
+	                     fd_sock, LIBCAPSICUM_CAPMASK_SOCK) < 0)
+		err(-1, "Error in lc_fdlist_addcap(fd_sock)");
+
+	if (lc_fdlist_addcap(fds, LIBCAPSICUM_FQNAME, "fdlist", "",
+	                     shmfd, LIBCAPSICUM_CAPMASK_FDLIST) < 0)
+		err(-1, "Error in lc_fdlist_addcap(shmfd)");
+
+	if (lc_fdlist_addcap(fds, RTLD_CAP_FQNAME, "rtld", "",
+	                     fd_rtld, LIBCAPSICUM_CAPMASK_LDSO) < 0)
+		err(-1, "Error in lc_fdlist_addcap(fd_rtld)");
+
+	if (lc_fdlist_addcap(fds, RTLD_CAP_FQNAME, "binary", "",
+	                     fd_binary, LIBCAPSICUM_CAPMASK_SANDBOX) < 0)
+		err(-1, "Error in lc_fdlist_addcap(fd_binary)");
+
+	if (lc_fdlist_append(fds, userfds) < 0)
+		err(-1, "Error in lc_fdlist_append()");
+
+	/*
+	 * Ask RTLD for library path descriptors.
+	 *
+	 * NOTE: This is FreeBSD-specific; porting to other operating systems
+	 * will require dynamic linkers capable of answering similar queries.
+	 */
+	int size = 16;
+	int *libdirs;
+
+	while (1) {
+		libdirs = malloc(size * sizeof(int));
+		if (ld_libdirs(libdirs, &size) < 0) {
+			free(libdirs);
+			if (size > 0)
+				continue;
+			err(-1, "Error in ld_libdirs()");
+		} else
+			break;
+	}
+
+	for (int j = 0; j < size; j++)
+		if (lc_fdlist_addcap(fds, RTLD_CAP_FQNAME, "libdir", "",
+		    libdirs[j], LIBCAPSICUM_CAPMASK_LIBDIR) < 0)
+			err(-1, "Error in lc_fdlist_addcap(libdirs[%d]: %d)",
+			    j, libdirs[j]);
+
+	if (lc_fdlist_reorder(fds) < 0)
+		err(-1, "Error in lc_fdlist_reorder()");
+
+	/*
+	 * Find the fdlist shared memory segment.
+	 */
+	int pos = 0;
+	if (lc_fdlist_lookup(fds, LIBCAPSICUM_FQNAME, "fdlist", NULL, &shmfd,
+	    &pos) < 0)
+		err(-1, "Error in lc_fdlist_lookup(fdlist)");
+
+	char tmp[8];
+	sprintf(tmp, "%d", shmfd);
+	if (setenv(LIBCAPSICUM_SANDBOX_FDLIST, tmp, 1) == -1)
+		err(-1, "Error in setenv(LIBCAPSICUM_SANDBOX_FDLIST)");
+
+	/*
+	 * Map it and copy the list.
+	 */
+	fdlistsize = lc_fdlist_size(fds);
+	if (ftruncate(shmfd, fdlistsize) < 0)
+		err(-1, "Error in ftruncate(shmfd)");
+
+	shm = mmap(NULL, fdlistsize, PROT_READ | PROT_WRITE,
+	    MAP_NOSYNC | MAP_SHARED, shmfd, 0);
+	if (shm == MAP_FAILED)
+		err(-1, "Error mapping fdlist SHM");
+
+	memcpy(shm, _lc_fdlist_getstorage(fds), fdlistsize);
+	if (munmap(shm, fdlistsize))
+		err(-1, "Error in munmap(shm, fdlistsize)");
+
+
+	/*
+	 * Find RTLD.
+	 */
+	if (lc_fdlist_lookup(fds, RTLD_CAP_FQNAME, "rtld", NULL, &fd_rtld,
+	                     NULL) < 0)
+		err(-1, "Error in lc_fdlist_lookup(RTLD)");
+
+	/*
+	 * Find the binary for RTLD.
+	 */
+	if (lc_fdlist_lookup(fds, RTLD_CAP_FQNAME, "binary", NULL,
+	    &fd_binary, NULL) < 0)
+		err(-1, "Error in lc_fdlist_lookup(RTLD binary)");
+
+	sprintf(tmp, "%d", fd_binary);
+	if (setenv("LD_BINARY", tmp, 1) != 0)
+		err(-1, "Error in setenv(LD_BINARY)");
+
+	/*
+	 * Build LD_LIBRARY_DIRS for RTLD.
+	 *
+	 * NOTE: This is FreeBSD-specific; porting to other operating systems
+	 * will require dynamic linkers capable of operating on file
+	 * descriptors.
+	 */
+	sbufp = sbuf_new_auto();
+	if (sbufp == NULL)
+		err(-1, "Error in sbuf_new_auto()");
+
+	{
+		int fd;
+		while (lc_fdlist_lookup(fds, RTLD_CAP_FQNAME, "libdir", NULL,
+		    &fd, &pos) >= 0)
+			sbuf_printf(sbufp, "%d:", fd);
+	}
+
+	sbuf_finish(sbufp);
+	if (sbuf_overflowed(sbufp))
+		err(-1, "sbuf_overflowed()");
+	if (setenv("LD_LIBRARY_DIRS", sbuf_data(sbufp), 1) == -1)
+		err(-1, "Error in setenv(LD_LIBRARY_DIRS)");
+	sbuf_delete(sbufp);
+
+	if (cap_enter() < 0)
+		err(-1, "cap_enter() failed");
+
+	(void)fexecve(fd_rtld, argv, environ);
+}
+
+int
+lch_startfd(int fd_binary, const char *binname, char *const argv[],
+    u_int flags, struct lc_fdlist *fds, struct lc_sandbox **lcspp)
+{
+	struct lc_sandbox *lcsp;
+	int fd_rtld;
+	int fd_procdesc, fd_sockpair[2];
+	int error, val;
+	pid_t pid;
+
+	fd_rtld = fd_procdesc = fd_sockpair[0] = fd_sockpair[1] = -1;
+
+	lcsp = malloc(sizeof(*lcsp));
+	if (lcsp == NULL)
+		return (-1);
+	bzero(lcsp, sizeof(*lcsp));
+
+	if (ld_insandbox()) {
+		struct lc_fdlist *globals;
+		int pos = 0;
+
+		globals = lc_fdlist_global();
+		if (globals == NULL)
+			goto out_error;
+		if (lc_fdlist_lookup(globals, RTLD_CAP_FQNAME, "rtld", NULL,
+		    &fd_rtld, &pos) < 0)
+			goto out_error;
+	} else {
+		fd_rtld = open(PATH_LD_ELF_CAP_SO "/" LD_ELF_CAP_SO,
+		    O_RDONLY);
+		if (fd_rtld < 0)
+			goto out_error;
+	}
+
+	if (socketpair(PF_LOCAL, SOCK_STREAM, 0, fd_sockpair) < 0)
+		goto out_error;
+
+	val = 1;
+	if (setsockopt(fd_sockpair[0], SOL_SOCKET, SO_NOSIGPIPE, &val,
+	    sizeof(val)) < 0) {
+		fd_sockpair[0] = fd_sockpair[1] = -1;
+		goto out_error;
+	}
+
+	pid = pdfork(&fd_procdesc);
+	if (pid < 0) {
+		fd_procdesc = -1;
+		goto out_error;
+	}
+	if (pid == 0) {
+		lch_sandbox(fd_sockpair[1], fd_binary, fd_rtld, flags,
+		    binname, argv, fds);
+		exit(-1);
+	}
+	if (fd_rtld != -1)
+		close(fd_rtld);
+	close(fd_sockpair[1]);
+
+	lcsp->lcs_fd_procdesc = fd_procdesc;
+	lcsp->lcs_fd_sock = fd_sockpair[0];
+	lcsp->lcs_pid = pid;
+	*lcspp = lcsp;
+
+	return (0);
+
+out_error:
+	error = errno;
+	if (fd_sockpair[0] != -1)
+		close(fd_sockpair[0]);
+	if (fd_sockpair[1] != -1)
+		close(fd_sockpair[1]);
+	if (fd_rtld != -1)
+		close(fd_rtld);
+	if (lcsp != NULL)
+		free(lcsp);
+	errno = error;
+	return (-1);
+}
+
+int
+lch_start(const char *sandbox, char *const argv[], u_int flags,
+    struct lc_fdlist *fds, struct lc_sandbox **lcspp)
+{
+	char binname[MAXPATHLEN];
+	int error, fd_binary, ret;
+
+	if (basename_r(sandbox, binname) == NULL)
+		return (-1);
+
+	fd_binary = open(sandbox, O_RDONLY);
+	if (fd_binary < 0)
+		return (-1);
+
+	ret = lch_startfd(fd_binary, binname, argv, flags, fds, lcspp);
+	error = errno;
+	close(fd_binary);
+	errno = error;
+	return (ret);
+}
+
+void
+lch_stop(struct lc_sandbox *lcsp)
+{
+
+	close(lcsp->lcs_fd_sock);
+	close(lcsp->lcs_fd_procdesc);
+	lcsp->lcs_fd_sock = -1;
+	lcsp->lcs_fd_procdesc = -1;
+	lcsp->lcs_pid = -1;
+}
+
+int
+lch_getsock(struct lc_sandbox *lcsp, int *fdp)
+{
+
+	*fdp = lcsp->lcs_fd_sock;
+	return (0);
+}
+
+int
+lch_getpid(struct lc_sandbox *lcsp, pid_t *pidp)
+{
+
+	*pidp = lcsp->lcs_pid;
+	return (0);
+}
+
+int
+lch_getprocdesc(struct lc_sandbox *lcsp, int *fdp)
+{
+
+	*fdp = lcsp->lcs_fd_procdesc;
+	return (0);
+}
Index: lib/libcapsicum/libcapsicum_sandbox.c
===================================================================
--- lib/libcapsicum/libcapsicum_sandbox.c	(.../stable/8)	(revision 0)
+++ lib/libcapsicum/libcapsicum_sandbox.c	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,89 @@
+/*-
+ * Copyright (c) 2009 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * WARNING: THIS IS EXPERIMENTAL SECURITY SOFTWARE THAT MUST NOT BE RELIED
+ * ON IN PRODUCTION SYSTEMS.  IT WILL BREAK YOUR SOFTWARE IN NEW AND
+ * UNEXPECTED WAYS.
+ *
+ * This software was developed at the University of Cambridge Computer
+ * Laboratory with support from a grant from Google, Inc.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD$");
+
+#include <sys/types.h>
+#include <sys/capability.h>
+#include <sys/socket.h>
+#include <sys/uio.h>
+
+#include <errno.h>
+#include <limits.h>
+#include <stdio.h>   /* TODO: temporary */
+#include <stdlib.h>
+#include <string.h>
+
+#include "libcapsicum.h"
+#include "libcapsicum_internal.h"
+#include "libcapsicum_sandbox_api.h"
+
+static int		lch_initialized;
+static struct lc_host	lch_global;
+
+int
+lcs_get(struct lc_host **lchpp)
+{
+	int fd_sock;
+
+	if (lch_initialized) {
+		*lchpp = &lch_global;
+		return (0);
+	}
+
+	if (!ld_insandbox()) {
+		errno = EINVAL;
+		return (-1);
+	}
+
+	struct lc_fdlist *fds = lc_fdlist_global();
+	if (lc_fdlist_lookup(fds, LIBCAPSICUM_FQNAME, "socket", NULL,
+	                     &fd_sock, NULL) < 0)
+		return (-1);
+	if (fd_sock == -1)
+		return (-1);
+
+	lch_global.lch_fd_sock = fd_sock;
+	lch_initialized = 1;
+	*lchpp = &lch_global;
+	return (0);
+}
+
+int
+lcs_getsock(struct lc_host *lchp, int *fdp)
+{
+
+	*fdp = lchp->lch_fd_sock;
+	return (0);
+}
Index: lib/libcapsicum/libcapsicum.c
===================================================================
--- lib/libcapsicum/libcapsicum.c	(.../stable/8)	(revision 0)
+++ lib/libcapsicum/libcapsicum.c	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,268 @@
+/*-
+ * Copyright (c) 2009 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * WARNING: THIS IS EXPERIMENTAL SECURITY SOFTWARE THAT MUST NOT BE RELIED
+ * ON IN PRODUCTION SYSTEMS.  IT WILL BREAK YOUR SOFTWARE IN NEW AND
+ * UNEXPECTED WAYS.
+ *
+ * This software was developed at the University of Cambridge Computer
+ * Laboratory with support from a grant from Google, Inc.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $P4: //depot/projects/trustedbsd/capabilities/src/lib/libcapsicum/libcapsicum.c#4 $
+ */
+
+#include <sys/types.h>
+#include <sys/capability.h>
+#include <sys/socket.h>
+
+#include <errno.h>
+#include <string.h>
+#include <unistd.h>
+
+#include "libcapsicum.h"
+#include "libcapsicum_internal.h"
+#include "libcapsicum_sandbox_api.h"
+
+int
+lc_limitfd(int fd, cap_rights_t rights)
+{
+	int fd_cap;
+	int error;
+
+	fd_cap = cap_new(fd, rights);
+	if (fd_cap < 0)
+		return (-1);
+	if (dup2(fd_cap, fd) < 0) {
+		error = errno;
+		close(fd_cap);
+		errno = error;
+		return (-1);
+	}
+	close(fd_cap);
+	return (0);
+}
+
+void
+_lc_dispose_rights(int *fdp, int fdcount)
+{
+	int i;
+
+	for (i = 0; i < fdcount; i++)
+		close(fdp[i]);
+}
+
+/*
+ * Given a 'struct msghdr' returned by a successful call to recvmsg(),
+ * extract up to the desired number of file descriptors (or clean up the
+ * mess if something goes wrong).
+ */
+int
+_lc_receive_rights(struct msghdr *msg, int *fdp, int *fdcountp)
+{
+	int *cmsg_fdp, fdcount, i, scmrightscount;
+	struct cmsghdr *cmsg;
+
+	/*
+	 * Walk the complete control message chain to count received control
+	 * messages and rights.  If there is more than one rights message or
+	 * there are too many file descriptors, re-walk and close them all
+	 * and return an error.
+	 */
+	fdcount = 0;
+	scmrightscount = 0;
+	for (cmsg = CMSG_FIRSTHDR(msg); cmsg != NULL;
+	    cmsg = CMSG_NXTHDR(msg, cmsg)) {
+		if (cmsg->cmsg_level != SOL_SOCKET ||
+		    cmsg->cmsg_type != SCM_RIGHTS)
+			continue;
+		fdcount += (cmsg->cmsg_len - CMSG_LEN(0)) / sizeof(int);
+		scmrightscount++;
+	}
+	if (scmrightscount > 1 || fdcount > *fdcountp) {
+		for (cmsg = CMSG_FIRSTHDR(msg); cmsg != NULL;
+		    cmsg = CMSG_NXTHDR(msg, cmsg)) {
+			if (cmsg->cmsg_level != SOL_SOCKET ||
+			    cmsg->cmsg_type != SCM_RIGHTS)
+				continue;
+			cmsg_fdp = (int *)CMSG_DATA(cmsg);
+			fdcount = (cmsg->cmsg_len - CMSG_LEN(0)) /
+			    sizeof(int);
+			_lc_dispose_rights(cmsg_fdp, fdcount);
+		}
+		errno = EBADMSG;
+		return (-1);
+	}
+
+	/*
+	 * Re-walk the control messages and copy out the file descriptor
+	 * numbers, return success.  No need to recalculate fdcount.
+	 */
+	for (cmsg = CMSG_FIRSTHDR(msg); cmsg != NULL;
+	    cmsg = CMSG_NXTHDR(msg, cmsg)) {
+		if (cmsg->cmsg_level != SOL_SOCKET ||
+		    cmsg->cmsg_type != SCM_RIGHTS)
+			continue;
+		cmsg_fdp = (int *)CMSG_DATA(cmsg);
+		for (i = 0; i < fdcount; i++)
+			fdp[i] = cmsg_fdp[i];
+	}
+	*fdcountp = fdcount;
+	return (0);
+}
+
+ssize_t
+_lc_send(int fd, const void *msg, size_t len, int flags, int lc_flags)
+{
+	ssize_t retlen;
+
+	if (fd == -1 || fd == 0) {
+		errno = ECHILD;
+		return (-1);
+	}
+	if (lc_flags & LC_IGNOREEINTR) {
+		do {
+			retlen = send(fd, msg, len, flags);
+		} while (retlen < 0 && errno == EINTR);
+	} else
+		retlen = send(fd, msg, len, flags);
+	return (retlen);
+}
+
+ssize_t
+_lc_send_rights(int fd, const void *msg, size_t len, int flags, int lc_flags,
+    int *fdp, int fdcount)
+{
+	char cmsgbuf[CMSG_SPACE(LIBCAPSICUM_SANDBOX_API_MAXRIGHTS *
+	    sizeof(int))];
+	struct cmsghdr *cmsg;
+	struct msghdr msghdr;
+	struct iovec iov;
+	ssize_t retlen;
+	int i;
+
+	if (fdcount == 0)
+		return (_lc_send(fd, msg, len, flags, lc_flags));
+
+	if (fd == -1 || fd == 0) {
+		errno = ECHILD;
+		return (-1);
+	}
+
+	if (fdcount > LIBCAPSICUM_SANDBOX_API_MAXRIGHTS) {
+		errno = EMSGSIZE;
+		return (-1);
+	}
+
+	bzero(&iov, sizeof(iov));
+	iov.iov_base = __DECONST(void *, msg);
+	iov.iov_len = len;
+
+	bzero(&cmsgbuf, sizeof(cmsgbuf));
+	cmsg = (struct cmsghdr *)cmsgbuf;
+	cmsg->cmsg_len = CMSG_SPACE(fdcount * sizeof(int));
+	cmsg->cmsg_level = SOL_SOCKET;
+	cmsg->cmsg_type = SCM_RIGHTS;
+	for (i = 0; i < fdcount; i++)
+		((int *)CMSG_DATA(cmsg))[i] = fdp[i];
+
+	bzero(&msghdr, sizeof(msghdr));
+	msghdr.msg_iov = &iov;
+	msghdr.msg_iovlen = 1;
+	msghdr.msg_control = cmsg;
+	msghdr.msg_controllen = cmsg->cmsg_len;
+
+	if (lc_flags & LC_IGNOREEINTR) {
+		do {
+			retlen = sendmsg(fd, &msghdr, flags);
+		} while (retlen < 0 && errno == EINTR);
+	} else
+		retlen = sendmsg(fd, &msghdr, flags);
+	return (retlen);
+}
+
+ssize_t
+_lc_recv(int fd, void *buf, size_t len, int flags, int lc_flags)
+{
+	ssize_t retlen;
+
+	if (fd == -1 || fd == 0) {
+		errno = ESRCH;
+		return (-1);
+	}
+	if (lc_flags & LC_IGNOREEINTR) {
+		do {
+			retlen = recv(fd, buf, len, flags);
+		} while (retlen < 0 && errno == EINTR);
+		return (retlen);
+	} else
+		return (recv(fd, buf, len, flags));
+}
+
+ssize_t
+_lc_recv_rights(int fd, void *buf, size_t len, int flags, int lc_flags,
+    int *fdp, int *fdcountp)
+{
+	char cmsgbuf[CMSG_SPACE(LIBCAPSICUM_SANDBOX_API_MAXRIGHTS *
+	    sizeof(int))];
+	struct msghdr msghdr;
+	struct iovec iov;
+	ssize_t retlen;
+
+	if (*fdcountp == 0)
+		return (_lc_recv(fd, buf, len, flags, lc_flags));
+
+	if (fd == -1 || fd == 0) {
+		errno = ECHILD;
+		return (-1);
+	}
+
+	if (*fdcountp > LIBCAPSICUM_SANDBOX_API_MAXRIGHTS) {
+		errno = EMSGSIZE;
+		return (-1);
+	}
+
+	bzero(&iov, sizeof(iov));
+	iov.iov_base = buf;
+	iov.iov_len = len;
+
+	bzero(cmsgbuf, sizeof(cmsgbuf));
+	bzero(&msghdr, sizeof(msghdr));
+	msghdr.msg_iov = &iov;
+	msghdr.msg_iovlen = 1;
+	msghdr.msg_control = cmsgbuf;
+	msghdr.msg_controllen = sizeof(cmsgbuf);
+
+	if (lc_flags & LC_IGNOREEINTR) {
+		do {
+			retlen = recvmsg(fd, &msghdr, flags);
+		} while (retlen < 0 && errno == EINTR);
+	} else
+		retlen = recvmsg(fd, &msghdr, flags);
+	if (retlen < 0)
+		return (-1);
+	if (_lc_receive_rights(&msghdr, fdp, fdcountp) < 0)
+		return (-1);
+	return (retlen);
+}
Index: lib/libcapsicum/Makefile
===================================================================
--- lib/libcapsicum/Makefile	(.../stable/8)	(revision 0)
+++ lib/libcapsicum/Makefile	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,59 @@
+# $FreeBSD$
+
+LIB=	capsicum
+DPADD=	${LIBSBUF}
+LDADD=	-lsbuf
+
+SRCS=					\
+	libcapsicum.c			\
+	libcapsicum_sandbox.c		\
+	libcapsicum_sandbox_io.c	\
+	libcapsicum_host.c		\
+	libcapsicum_host_io.c		\
+	libcapsicum_fdlist.c
+
+INCS=	libcapsicum.h
+
+CFLAGS+=	-I.
+
+SHLIB_MAJOR=	1
+
+WARNS?=	6
+
+MAN=	libcapsicum.3
+MAN+=	libcapsicum_fdlist.3
+MAN+=	libcapsicum_host.3
+MAN+=	libcapsicum_sandbox.3
+MLINKS=	libcapsicum.3 lc_limitfd.3		\
+	libcapsicum_fdlist.3 lc_fdlist_new.3	\
+	libcapsicum_fdlist.3 lc_fdlist_global.3	\
+	libcapsicum_fdlist.3 lc_fdlist_dup.3	\
+	libcapsicum_fdlist.3 lc_fdlist_free.3	\
+	libcapsicum_fdlist.3 lc_fdlist_add.3	\
+	libcapsicum_fdlist.3 lc_fdlist_addcap.3	\
+	libcapsicum_fdlist.3 lc_fdlist_lookup.3	\
+	libcapsicum_host.3 lch_autosandbox_isenabled.3	\
+	libcapsicum_host.3 lch_start.3	\
+	libcapsicum_host.3 lch_startfd.3	\
+	libcapsicum_host.3 lch_stop.3		\
+	libcapsicum_host.3 lch_getsock.3	\
+	libcapsicum_host.3 lch_getpid.3	\
+	libcapsicum_host.3 lch_getprocdesc.3	\
+	libcapsicum_host.3 lch_recv.3		\
+	libcapsicum_host.3 lch_recv_rights.3	\
+	libcapsicum_host.3 lch_rpc.3		\
+	libcapsicum_host.3 lch_rpc_rights.3	\
+	libcapsicum_host.3 lch_send.3		\
+	libcapsicum_host.3 lch_send_rights.3	\
+	libcapsicum_sandbox.3 lcs_get.3	\
+	libcapsicum_sandbox.3 lcs_getsock.3	\
+	libcapsicum_sandbox.3 lcs_recv.3	\
+	libcapsicum_sandbox.3 lcs_recv_rights.3	\
+	libcapsicum_sandbox.3 lcs_recvrpc.3	\
+	libcapsicum_sandbox.3 lcs_recvrpc_rights.3	\
+	libcapsicum_sandbox.3 lcs_send.3	\
+	libcapsicum_sandbox.3 lcs_send_rights.3	\
+	libcapsicum_sandbox.3 lcs_sendrpc.3	\
+	libcapsicum_sandbox.3 lcs_sendrpc_rights.3
+
+.include <bsd.lib.mk>
Index: lib/libcapsicum/libcapsicum_internal.h
===================================================================
--- lib/libcapsicum/libcapsicum_internal.h	(.../stable/8)	(revision 0)
+++ lib/libcapsicum/libcapsicum_internal.h	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,71 @@
+/*-
+ * Copyright (c) 2009 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * WARNING: THIS IS EXPERIMENTAL SECURITY SOFTWARE THAT MUST NOT BE RELIED
+ * ON IN PRODUCTION SYSTEMS.  IT WILL BREAK YOUR SOFTWARE IN NEW AND
+ * UNEXPECTED WAYS.
+ *
+ * This software was developed at the University of Cambridge Computer
+ * Laboratory with support from a grant from Google, Inc.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $P4: //depot/projects/trustedbsd/capabilities/src/lib/libcapsicum/libcapsicum_internal.h#6 $
+ */
+
+#ifndef _LIBCAPSICUM_INTERNAL_H_
+#define	_LIBCAPSICUM_INTERNAL_H_
+
+#define	LIBCAPSICUM_FQNAME	"org.freebsd.libcapsicum"
+#define	RTLD_CAP_FQNAME		"org.freebsd.rtld-elf-cap"
+
+struct lc_host {
+	int	lch_fd_sock;
+};
+
+struct lc_sandbox {
+	int	lcs_fd_sock;
+	int	lcs_fd_procdesc;
+	pid_t	lcs_pid;
+};
+
+void*	_lc_fdlist_getstorage(struct lc_fdlist*);
+
+/*
+ * Communications flags for recv/send calls (lc_flags).
+ */
+#define	LC_IGNOREEINTR	0x00000001
+
+struct msghdr;
+void	_lc_dispose_rights(int *fdp, int fdcount);
+int	_lc_receive_rights(struct msghdr *msg, int *fdp, int *fdcountp);
+
+ssize_t	_lc_recv(int fd, void *buf, size_t len, int flags, int lc_flags);
+ssize_t	_lc_recv_rights(int fd, void *buf, size_t len, int flags,
+	    int lc_flags, int *fdp, int *fdcountp);
+ssize_t	_lc_send(int fd, const void *msg, size_t len, int flags,
+	    int lc_flags);
+ssize_t	_lc_send_rights(int fd, const void *msg, size_t len, int flags,
+	    int lc_flags, int *fdp, int fdcount);
+
+#endif /* !_LIBCAPSICUM_INTERNAL_H_ */
Index: lib/csu/common/crtbrand.c
===================================================================
--- lib/csu/common/crtbrand.c	(.../stable/8)	(revision 201781)
+++ lib/csu/common/crtbrand.c	(.../projects/capabilities8)	(revision 205872)
@@ -27,6 +27,7 @@
 __FBSDID("$FreeBSD$");
 
 #include <sys/param.h>
+#include <unistd.h>
 
 #define ABI_VENDOR	"FreeBSD"
 #define ABI_SECTION	".note.ABI-tag"
@@ -50,3 +51,13 @@
     ABI_VENDOR,
     __FreeBSD_version
 };
+
+extern int cap_main(int, char **, char **) __attribute__((weak));
+int cap_main(__unused int argc, __unused char **argv, __unused char **env)
+{
+	const char warning[] =
+		"ERROR: attempting to run a regular binary in capability mode!\n\nIf you want to run a binary in a sandbox, you must provide a cap_main() function, which takes the same arguments as main().\n";
+
+	write(2, warning, sizeof(warning));
+	return (-1);
+}
Index: lib/csu/amd64/crt1.c
===================================================================
--- lib/csu/amd64/crt1.c	(.../stable/8)	(revision 201781)
+++ lib/csu/amd64/crt1.c	(.../projects/capabilities8)	(revision 205872)
@@ -31,6 +31,7 @@
 #endif /* lint */
 
 #include <stdlib.h>
+#include <unistd.h>
 
 #include "libc_private.h"
 #include "crtbrand.c"
@@ -44,6 +45,7 @@
 extern void _init(void);
 extern int main(int, char **, char **);
 extern void _start(char **, void (*)(void));
+extern void _capstart(char **, void (*)(void));
 
 #ifdef GCRT
 extern void _mcleanup(void);
@@ -92,4 +94,41 @@
 	exit( main(argc, argv, env) );
 }
 
+/* The Capsicum entry function. */
+void
+_capstart(char **ap, void (*cleanup)(void))
+{
+	int argc;
+	char **argv;
+	char **env;
+	const char *s;
+
+	argc = *(long *)(void *)ap;
+	argv = ap + 1;
+	env = ap + 2 + argc;
+	environ = env;
+	if (argc > 0 && argv[0] != NULL) {
+		__progname = argv[0];
+		for (s = __progname; *s != '\0'; s++)
+			if (*s == '/')
+				__progname = s + 1;
+	}
+
+	if (&_DYNAMIC != NULL)
+		atexit(cleanup);
+	else
+		_init_tls();
+
+#ifdef GCRT
+	atexit(_mcleanup);
+#endif
+	atexit(_fini);
+#ifdef GCRT
+/*	monstartup(&eprol, &etext);*/
+/*__asm__("eprol:");*/             /* JA hope and pray... */
+#endif
+	_init();
+	exit( cap_main(argc, argv, env) );
+}
+
 __asm__(".ident\t\"$FreeBSD$\"");
Index: lib/csu/i386-elf/crt1_c.c
===================================================================
--- lib/csu/i386-elf/crt1_c.c	(.../stable/8)	(revision 201781)
+++ lib/csu/i386-elf/crt1_c.c	(.../projects/capabilities8)	(revision 205872)
@@ -46,6 +46,7 @@
 extern void _init(void);
 extern int main(int, char **, char **);
 extern void _start(char *, ...);
+extern void _capstart(char *, ...);
 
 #ifdef GCRT
 extern void _mcleanup(void);
@@ -58,6 +59,7 @@
 const char *__progname = "";
 
 void _start1(fptr, int, char *[]) __dead2;
+void _capstart1(fptr, int, char *[]) __dead2;
 
 /* The entry function, C part. */
 void
@@ -93,3 +95,38 @@
 }
 
 __asm(".hidden	_start1");
+
+/* The Capsicum entry function. */
+void
+_capstart1(fptr cleanup, int argc, char *argv[])
+{
+	char **env;
+	const char *s;
+
+	env = argv + argc + 1;
+	environ = env;
+	if (argc > 0 && argv[0] != NULL) {
+		__progname = argv[0];
+		for (s = __progname; *s != '\0'; s++)
+			if (*s == '/')
+				__progname = s + 1;
+	}
+
+	if (&_DYNAMIC != NULL)
+		atexit(cleanup);
+	else
+		_init_tls();
+
+#ifdef GCRT
+	atexit(_mcleanup);
+#endif
+	atexit(_fini);
+#ifdef GCRT
+/* XXXCAP:	monstartup(&eprol, &etext); */
+/* XXXCAP: __asm__("eprol:"); */
+#endif
+	_init();
+	exit( cap_main(argc, argv, env) );
+}
+
+__asm(".hidden	_capstart1");
Index: lib/csu/i386-elf/crt1_s.S
===================================================================
--- lib/csu/i386-elf/crt1_s.S	(.../stable/8)	(revision 201781)
+++ lib/csu/i386-elf/crt1_s.S	(.../projects/capabilities8)	(revision 205872)
@@ -41,4 +41,17 @@
 	call	_start1
 	.size	_start, . - _start
 
+	.globl	_capstart
+	.type	_capstart, @function
+_capstart:	xorl	%ebp,%ebp
+	pushl	%ebp
+	movl	%esp,%ebp
+	andl	$0xfffffff0,%esp # align stack
+	leal	8(%ebp),%eax
+	pushl	%eax		# argv
+	pushl	4(%ebp)		# argc
+	pushl	%edx		# rtld cleanup
+	call	_capstart1
+	.size	_capstart, . - _capstart
+
 	.ident	"$FreeBSD$"
Index: lib/csu/i386-elf/Makefile
===================================================================
--- lib/csu/i386-elf/Makefile	(.../stable/8)	(revision 201781)
+++ lib/csu/i386-elf/Makefile	(.../projects/capabilities8)	(revision 205872)
@@ -21,13 +21,13 @@
 
 crt1.o:	crt1_c.o crt1_s.o
 	${LD} ${LDFLAGS} -o crt1.o -r crt1_s.o crt1_c.o
-	objcopy --localize-symbol _start1 crt1.o
+	objcopy --localize-symbol _start1 --localize-symbol _capstart1 crt1.o
 
 Scrt1_c.o:	crt1_c.c
 	${CC} ${CFLAGS} -DGCRT -fPIC -DPIC -c -o Scrt1_c.o ${.CURDIR}/crt1_c.c
 
 Scrt1.o: Scrt1_c.o crt1_s.o
 	${LD} ${LDFLAGS} -o Scrt1.o -r crt1_s.o Scrt1_c.o
-	objcopy --localize-symbol _start1 Scrt1.o
+	objcopy --localize-symbol _start1 --localize-symbol _capstart1 Scrt1.o
 
 .include <bsd.prog.mk>

